# ADDSHIFT - Shift traces in ap* database file in X and Y
#
# January 7, 2004
# By Doug Mink, SAO Telescope Data Center

procedure addshift (infile, outfile)

file	infile=""	{prompt="Aperture reference image to be modified"}
file	indir=""	{prompt="Directory for input aperture file"}
file	outfile=""	{prompt="Output aperture file"}
file	shiftfile=""	{prompt="File containing shifts per aperture"}
real	xshift=0.0	{prompt="X shift in pixels"}
real	yshift=0.0	{prompt="Y shift in pixels"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}
bool	debug=no	{prompt="Print each ap modification (y or n)"}

begin

file	sfile, outpath, inpath, outf, inf, outpath1
file	inapfile, outapfile
string	arg
bool	oneshift
bool	vb, db
real	xs, ys
int	i, j

	vb = verbose
	db = debug
	inf = infile
	outf = outfile
	sfile = shiftfile
	if (sfile == "") {
	    oneshift = yes
	    xs = xshift
	    ys = yshift
	    }
	else {
	    oneshift = no
	    }

# Set input aperture file path
	inapfile = "ap" // inf
	if (indir == "") {
	    inpath = "database/" // inapfile
	    }
	else {
	    inpath = indir // "/database/" // inapfile
	    }
	    
# Set path for modified aperture file
	outapfile = "ap" // outf
	outpath = "database/" // outapfile

# Set up arguments and run shiftap shell script
	if (oneshift) {
	    arg = " -x " // xs // " -y " // ys
	    }
	else {
	    arg = " -s " // sfile
	    }
	if (db) {
	    arg = arg // " -vv "
	    }
	else if (vb) {
	    arg = arg // " -v "
	    }
	arg = arg // " -i " // inpath // " -o " // outpath
	if (db) {
	    print ("compshift ",arg)
	    }
	shiftap (arg)

# Change file name inside aperture database file
	outpath1 = outpath // "1"
	arg = "-e s/" // inf // "/" // outf // "/" // " <" // outpath // " >" // outpath1
	sed (arg)
	arg = outpath1 // " " // outpath
	mv (arg)

# Make .ms copy of aperture database file
	arg = " -p " // outpath // " " // outpath // ".ms"
	cp (arg)

# Link new image file name to original image file
	arg = outf // ".fits"
	if (!access (arg)) {
	    if (indir == "") {
		arg = inf // ".fits " // outf // ".fits"
		}
	    else {
		arg = indir // "/" // inf // ".fits " // outf // ".fits"
		}
	    if (db) {
		print ("ln -s ",arg)
		}
	    lns (arg)
	    }
end

# Dec 31 2003	New CL task to wrap Bill's shiftap task
#
# Jan  7 2004	Link new image file to original image file; make ap*.ms file
