# HFLAT -- Divide hectospec image by pixel normalization file from apflatten
#          saving original file in Unflat/
# By Doug Mink, SAO Telescope Data Center
# June 16, 2004

procedure hflat (input)

string	input = ""	{prompt="Input multispec image to correct"}
string	normfile=""	{prompt="Pixel to pixel normalization file from apflatten"}
bool deltemp = no	{prompt="Delete temporary files (y or n)"}
bool saveold = yes	{prompt="Save original file to Nonorm/ (y or n)"}
bool verbose = yes	{prompt="Log progress (y or n)"}

begin
	bool vb
	file imin, imout, imroot, imnorm, newfile
	int lroot
	string history

	imin = input
	vb = verbose
	imnorm = normfile

# Remove extension from input file, if one is present, and make output file name
	smatch (imin, ".fits")
	if (smatch.found) {
	    lroot = smatch.start - 1
	    imout = substr (imout, 1, lroot) // ".norm.fits"
	    }
	else {
	    imout = imin // ".norm.fits"
	    imin = imin // ".fits"
	    }

# Add FITS extension to normalization file if it is missing
	smatch (imnorm, ".fits")
	if (!smatch.found) {
	    imnorm = imnorm // ".fits"
	    }
	if (vb) {
	    print ("HFLAT: ", imin," -> ",imout," using ", imnorm)
	    }

# Divide out normalization spectra
	imarith (imin, "/", imnorm, imout)

# Move original file to Unflat directory
	if (saveold) {
	    if (!access ("Unflat/")) {
		mkdir ("Unflat")
		}
	    newfile = "Unflat/" // imin
	    if (access (newfile)) {
		imdelete (newfile)
		}
	    move (imin, "Unflat")
	    if (vb) {
		print ("HFLAT: Original ", imin, " => Unflat/")
		}
	    }
	else {
	    delete (imin)
	    }

# Rename result file to original file name
	rename (imout, imin)

# Add history line including time
	gettime ()
	history = gettime.date // " " // gettime.time // " pixels normalized by " // imnorm
        hedit (imin, "PIXNORM", history, add+, verify-)

end
# Jun 16 2004	Change name form HNORM2 to HFLAT
# Jun 16 2004	Move original file to Unflat/, not Nonorm/
