# HSPLIT - Split multispec hectospec file into 1-D spectra
# By Doug Mink, SAO Telescope Data Center
# June 9, 2004

procedure hsplit (msfile)

file	msfile=""	{prompt="Aperture reference multispec file (drop .ms)"}
file	keywords="hectospec$lib/keywords" {prompt="File containing header keywords to be deleted"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

begin

file	keyfile, keypath, imin, imroot
int	lroot
string	arg
bool	vb

	vb = verbose
	imin = msfile
	keyfile = keywords

# Make sure that input is a multispec file
	smatch (imin, ".ms")
	if (smatch.found) {
	    lroot = smatch.start - 1
	    imroot = substr (imin, 1, lroot)
	    }
        else {
	    smatch (imin, ".fits"
	    if (smatch.found) {
		print ("HSPLIT: ", imin," is not a multispec file")
		return
		}
	    imroot = imin
	    imin = imin // ".ms.fits"
	    if (!access (imin)) {
		print ("HSPLIT: ", imin," is not a multispec file")
		return
		}
            }

# Set list of keywords to delete from output files
	if (keyfile == "") {
	    keypath = ""
	    }
	else {
	    keypath = osfn (keywords)
	    }

# Set up arguments and run hsplit shell script
	if (keypath == "") {
	    arg = ""
	    }
	else {
	    arg = "-k " // keypath
	    }
	if (vb) {
	    arg = arg // " -v "
	    }
	arg = arg // " " // imroot
	hsplitsh (arg)

end

# Jan  8 2004	New script to run shell script
# Jun  9 2004	Deal with various forms of input filename
