# File procdata/Src/t_imgetp.x
# June 10, 2004
# Adaped from images.imgets by Doug Mink, SAO TElescope Data Center

include	<error.h>
include	<imhdr.h>
include	<ctype.h>
include	<ctotok.h>

# T_IMGETP -- Get the value of an image header parameter as a character string.
# The value is returned as a CL parameter of type string; the type coercion
# facilities of the CL may be used to convert to a different datatype if
# desired.

procedure t_imgetp()

pointer	sp, im
pointer	image, param, value, tvalue
pointer	immap()
char	comma
bool	clgetb()
bool	verbose
int	i, icomma, itok, ip, nc
int	ctoi(), stridx(), ctotok, clscan()

begin
	comma = ','
	call smark (sp)
	call salloc (image, SZ_FNAME, TY_CHAR)
	call salloc (param, SZ_FNAME, TY_CHAR)
	call salloc (value, SZ_LINE,  TY_CHAR)
	call salloc (tvalue, SZ_LINE,  TY_CHAR)
	Memc[value] = EOS

	call clgstr ("image", Memc[image], SZ_FNAME)

	call clgstr ("param", Memc[param], SZ_FNAME)

#  Get token number, if part of parameter name
	icomma = stridx (comma,Memc[param])
	if (icomma > 0) {
	    ip = icomma + 1
	    nc = ctoi (Memc[param],ip,itok)
	    Memc[param+icomma-1] = EOS
	    }
	else {
	    itok = 0
	    }

	verbose = clgetb ("verbose")

	im = immap (Memc[image], READ_ONLY, 0)

	iferr (call imgstr (im, Memc[param], Memc[value], SZ_LINE)) {
	    if (verbose) call erract (EA_WARN)
	    if (clscan("default") != EOF) {
		call clgstr ("default", Memc[value], SZ_LINE)
		call clpstr ("value", Memc[value])
		}
	    else
		call clpstr ("value", "0")
	    }
	else {
	    if (itok > 0) {
		ip = 1
		do i = 1, itok {
		    if (ctotok (Memc[value],ip,Memc[tvalue],SZ_LINE) == TOK_EOS) {
			call eprintf ("IMGETP:  Token %d not found; only %d\n")
			    call pargi (itok)
			    call pargi (i-1)
			break
			}
		    }
		call clpstr ("value", Memc[tvalue])
		if (verbose) {
		    call printf ("%s\n")
		    call pargstr (Memc[tvalue])
		    }
		}
	    else {
		call clpstr ("value", Memc[value])
		if (verbose) {
		    call printf ("%s\n")
		    call pargstr (Memc[value])
		    }
		}
	    }
	call imunmap (im)
	call sfree (sp)
end

# May 31 1995	Add token extraction

# Feb 11 1997	Add default value parameter

# Jun 10 2004	Initialize value to EOS to return null string if keyword not found
