# File archive/Src/t_smatch.x
# June 15, 1999
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# SMATCH -- return 1 if pattern is found in string, else 0

include <ctype.h>

int procedure t_smatch()

char	tstring[SZ_LINE], pattern[SZ_LINE]
int	i, strmatch(), strlen()
bool	found, verbose, clgetb()

begin
	verbose = clgetb ("verbose")

	call clgstr ("string", tstring, SZ_LINE)
	call clgstr ("pattern", pattern, SZ_LINE)
	i = strmatch (tstring, pattern) - strlen (pattern)
	call clputi ("start",i)
	if (i <= 0)
	    found = FALSE
	else
	    found = TRUE
	call clputb ("found",found)
	if (verbose) {
	    if (found) {
		call printf ("SMATCH: found %s in %s at %d\n")
		    call pargstr (pattern)
		    call pargstr (tstring)
		    call pargi (i)
		}
	    else {
		call printf ("SMATCH: could not find %s in %s\n")
		    call pargstr (pattern)
		    call pargstr (tstring)
		}
	    }
	return
end
# Feb 16 1995	New task

# Jul 13 1998	Write position of first matched character to parameter

# Jun 15 1999	Fix bug which always returned matches
