#{ HECTOSPEC package definition

noao
digiphot
apphot
astutil
twodspec
onedspec
imred
apextract
proto		# bscale

saotdc
procdata

s1 = envget ("min_lenuserarea")
if (s1 == "")
    reset min_lenuserarea = 100000
else if (int (s1) < 100000)
    reset min_lenuserarea = 100000

# Define HECTOSPEC package
set	hectbin		= "hectospec$bin(arch)/"
set	hectscripts	= "hectospec$Scripts/"
set	hectsrc		= "hectospec$Src/"
package hectospec, bin=hectbin$

set	doslit		= "noao$imred/src/doslit/"
cl < doslit$doslittasks.cl
task	sparams		= "specred$sparam"
task	apscript	= "hectospec$x_apextract.e"

task	centerpars	= "hectospec$centerpars.par"
task	datapars	= "hectospec$datapars.par"

# Fiber reduction script tasks
task	dohspec		= "hectscripts$dohspec.cl"
task	params		= "hectospec$params.par"
task	proc		= "hectscripts$proc.cl"
task	fibresponse	= "hectscripts$fibresponse.cl"
task	arcrefs		= "hectscripts$arcrefs.cl"
task	doarcs		= "hectscripts$doarcs.cl"
task	doalign		= "hectscripts$doalign.cl"
task	skysub		= "hectscripts$skysub.cl"
task	batch		= "hectscripts$batch.cl"
task	listonly	= "hectscripts$listonly.cl"
task	addshift	= "hectscripts$addshift.cl"
task	hcal		= "hectscripts$hcal.cl"
task	hextract	= "hectscripts$hextract.cl"
task	hflat		= "hectscripts$hflat.cl"
task	hlin		= "hectscripts$hlin.cl"
task	hmerge		= "hectscripts$hmerge.cl"
task	hnorm		= "hectscripts$hnorm.cl"
task	hproc		= "hectscripts$hproc.cl"
task	htran		= "hectscripts$htran.cl"
task	makeflat	= "hectscripts$makeflat.cl"
task	makenorm	= "hectscripts$makenorm.cl"
task	maketran	= "hectscripts$maketran.cl"
task	compshift	= "hectscripts$compshift.cl"
task	compshift1	= "hectscripts$compshift1.cl"
task	gaincorr	= "hectscripts$gaincorr.cl"
task	getspec		= "hectscripts$getspec.cl"
task	$preampfix	= "$"//osfn('hectbin$preampfix.e')
#task	mkxctemp	= "hectscripts$mkxctemp.cl"
#task	mkxctempw	= "hectscripts$mkxctempw.cl"
#task	xcpix		= "hectscripts$xcpix.cl"
#task	xcpix1		= "hectscripts$xcpix1.cl"
#task	xcsky		= "hectscripts$xcsky.cl"
#task	xcsky1		= "hectscripts$xcsky1.cl"
#task	xcpixl		= "hectscripts$xcpixl.cl"
#task	xcpixn		= "hectscripts$xcpixn.cl"
#task	fitpol		= "hectscripts$fitpol.cl"
#task	zap		= "hectscripts$zap.cl"

task	fxstat		= "hectscripts$fxstat.cl"

task	$idcombine	= "$"//osfn('hectospec$idcombine')
task	hsplit		= "hectscripts$hsplit.cl"
task	$hsplitsh	= "$"//osfn('hectscripts$hsplit.ksh')
task	$shiftap	= "$"//osfn('hectscripts$shiftap.ksh')
task	$add122		= "$"//osfn('hectscripts$add122.awk')
task	$add150		= "$"//osfn('hectscripts$add150.awk')
task	$hemapfix	= "hectscripts$hemapfix.cl"
task	$hsmapfix	= "hectscripts$hsmapfix.cl"
task	$hemapf		= "$"//osfn('hectscripts$hemapfix.awk')
task	$hsmapf		= "$"//osfn('hectscripts$hsmapfix.awk')
task	getrange	= "hectospec$x_hectospec.e"
task	gettime		= "hectospec$x_hectospec.e"
task	istat		= "hectospec$x_hectospec.e"
task	reref		= "hectospec$x_hectospec.e"
task	skycal		= "hectospec$x_hectospec.e"
task	smatch		= "hectospec$x_hectospec.e"
task	skxcsao		= "hectospec$skxcsao.par"
task	skemsao		= "hectospec$skemsao.par"
task	skimarith	= "hectospec$skimarith.par"
task	skimcombine	= "hectospec$skimcombine.par"
task	skimdelete	= "hectospec$skimdelete.par"
task	skimexpr	= "hectospec$skimexpr.par"
task	skimrename	= "hectospec$skimrename.par"
task	skimstack	= "hectospec$skimstack.par"
task	skimstatistics	= "hectospec$skimstatistics.par"

# Onedspec tasks
task	autoidentify,
	continuum,
	dispcor,
	dopcor,
	identify,
	refspectra,
	reidentify,
	sapertures,
	sarith,
	scombine,
	sflip,
	slist,
	specplot,
	specshift,
	splot		= "onedspec$x_onedspec.e"
task	aidpars		= "onedspec$aidpars.par"
#task	bplot		= "onedspec$bplot.cl"
#task	scopy		= "onedspec$scopy.cl"
#task	dispcor1	= "onedspec$dispcor1.par"

# Astutil tasks
task	setairmass,
	setjd		= "astutil$x_astutil.e"

# Package shell tasks
task	$skyprocksh	= "$"//osfn('hectscripts$skyproc.ksh')
task	skyproc		= "hectscripts$skyproc.cl"
task	$sethead	= $sethead

# Hide tasks from the user
hidetask apparams, apall1, apscript, apscat1, apscat2, dispcor1
#hidetask mkhect
hidetask params, proc, batch, arcrefs, doarcs, doalign, gettime
hidetask listonly, fibresponse, getspec, hsplitsh, skyprocksh

twodspec
imred
apextract
mscred
astutil
onedspec
type hectospec$hectospec.tasks

clbye()
